//191123 fujigaya2

#include <string.h>
#include "Keyboard.h"
#include "DenshaMascon.h"

Mascon Joystick;

#define EEP_ACC_RATE_DEFAULT 25
#define EEP_DEC_RATE_DEFAULT 15
#define EEP_COAST_RATE_DEFAULT 5

int joy_gear_mode = GEAR_MODE_SPD;//EEP_CONTROL_DEFAULT
int joy_accrate = EEP_ACC_RATE_DEFAULT;//50msecでどのくらい加速するか？２０４８が１００％の基準
int  joy_decrate = EEP_DEC_RATE_DEFAULT;
int  joy_coastrate = EEP_COAST_RATE_DEFAULT;
int prev_speed = 0;
unsigned int aPsxData = 0;
int gPreviousL6_wait = 50;

#define WAIT_KEY  333
#define WAIT_KEY_SPD  200
//Task Schedule
unsigned long gPreviousL5 = 250; //   50ms interval
unsigned long gPreviousL6 = 250; //   50ms interval

char aText[16 + 1];

void setup()
{
  // put your setup code here, to run once:
  //PSX
  Joystick.setupPins(MASCON_dataPin, MASCON_cmndPin, MASCON_attPin, MASCON_clockPin, 10);
  //Serial.begin(115200);
  //Serial.println("Serial Begin.");
}

void loop()
{
  // put your main code here, to run repeatedly:
  //Joystick
  if( (millis() - gPreviousL5) >= 50)
  {
    //Read joystick Status 
    aPsxData = Joystick.read();
    //検知用にバッファに入れておく
    Joystick.PutButtonBuffer(aPsxData);
    //Store status from aPsxData to gPower 
    Joystick.GetHandleStatus(aPsxData);
    //Read ButtonStatus and continueously push count    
    Joystick.GetButtonStatus(aPsxData);
    //Speed　→mode変えても変わらない？ 
    Joystick.Interval(joy_gear_mode ,joy_accrate,joy_decrate ,joy_coastrate );
    //Reset task
    gPreviousL5 = millis();
  }
  
  //buttonの確認
  if( (millis() - gPreviousL6) >= gPreviousL6_wait)
  {
    gPreviousL6_wait = 50;
    if((Joystick.GetButtonStatus(aPsxData) & JOYSTICK_SELECT) > 0)
    {
      //Serial.println("Select Button On.");
      Keyboard.print("0");
      gPreviousL6_wait = WAIT_KEY;
    }
    else if((Joystick.GetButtonStatus(aPsxData) & JOYSTICK_START) > 0)
    {
      //Serial.println("Start Button On.");
      Keyboard.print("z");
      gPreviousL6_wait = WAIT_KEY;
    }
    else if((Joystick.GetButtonStatus(aPsxData) & JOYSTICK_A) > 0)  
    {
      //Serial.println("A Button On.");
      Keyboard.print("1");
      gPreviousL6_wait = WAIT_KEY;
    }
    else if((Joystick.GetButtonStatus(aPsxData) & JOYSTICK_B) > 0)  
    {
      //Serial.println("B Button On.");
      Keyboard.print("2");
      gPreviousL6_wait = WAIT_KEY;
    }
    else if((Joystick.GetButtonStatus(aPsxData) & JOYSTICK_C) > 0)  
    {
      //Serial.println("C Button On.");
      Keyboard.print("3");
      gPreviousL6_wait = WAIT_KEY;
    }
    else
    {  
      //speed 値の確認！
      int joy_loco_speed = Joystick.GetSpeedValue() / 2;
      //値が違う時だけ送信！
      if(prev_speed != joy_loco_speed)
      {
        prev_speed = joy_loco_speed;
        sprintf(aText, "P%04d",joy_loco_speed);
        //Serial.print("Speed:");
        //Serial.println(aText);
        Keyboard.print(aText);
        gPreviousL6_wait = WAIT_KEY_SPD;
      }
    }
    //Reset task
    gPreviousL6 = millis();
  }
}

